proc setHints { } {
	global hint
set hint(.mb.file) {File Operations Menu}
set hint(.mb.file.m,1) {Start a new presentation}
set hint(.mb.file.m,2) {Open an existing presentation}
set hint(.mb.file.m,3) {Save the current presentation under a diffent name}
set hint(.mb.file.m,4) {Export the current presentation to PostScript}
set hint(.mb.file.m,6) {Change various Slide settings}
set hint(.mb.file.m,7) {Print the current presentation}
set hint(.mb.file.m,8) {Exit Slidedraw}

set hint(.mb.edit) {Editing Operations Menu}
set hint(.mb.edit.m,1) {Cut currently selected object to buffer}
set hint(.mb.edit.m,2) {Copy currently selected object to buffer}
set hint(.mb.edit.m,3) {Paste object(s) from buffer}
set hint(.mb.edit.m,4) {Copy all objects on slide to buffer}
set hint(.mb.edit.m,5) {Duplicate currently selected object}
set hint(.mb.edit.m,6) {Delete currently selected object}
set hint(.mb.edit.m,8) {Bring object to front}
set hint(.mb.edit.m,9) {Send object to back}
set hint(.mb.edit.m,10) {Group Objects}
set hint(.mb.edit.m,11) {Ungroup Objects}

set hint(.mb.format) {Formatting Operations Menu}

set hint(.mb.slide) {Slide Operations Menu}
set hint(.mb.slide.m,1) {Make a copy of the current slide}
set hint(.mb.slide.m,2) {Delete the current slide}
set hint(.mb.slide.m,3) {Goto the next slide}
set hint(.mb.slide.m,4) {Goto the previous slide}
set hint(.mb.slide.m,6) {Insert a slide after this one}
set hint(.mb.slide.m,8) {View the slide-show}
set hint(.mb.slide.m,9) {View all slides at once}

set hint(.mb.insert) {Insert Operations Menu}
set hint(.mb.insert.m,1) {Insert a box}
set hint(.mb.insert.m,2) {Insert a filled box}
set hint(.mb.insert.m,3) {Insert an ellipse}
set hint(.mb.insert.m,4) {Insert a filled ellipse}
set hint(.mb.insert.m,5) {Insert text}
set hint(.mb.insert.m,6) {Insert an image}
set hint(.mb.insert.m,7) {Insert a line}

set hint(.mb.view) {View Menu}
set hint(.mb.view.m,1) {Display/Remove Rulers}
set hint(.mb.view.m,3) {Zoom Control}

set hint(.mb.help) {Help Menu}

set hint(.bar.b0) {New File}
set hint(.bar.b1) {Open File}
set hint(.bar.b2) {Save File}
set hint(.bar.b3) {Print File}

set hint(.bar.b5) {Cut Object}
set hint(.bar.b6) {Copy Object}
set hint(.bar.b7) {Paste Object}

set hint(.bar.b9) {Create Frame}
set hint(.bar.b10) {Create Filled Frame}
set hint(.bar.b11) {Create Circle}
set hint(.bar.b12) {Create a filled Circle}
set hint(.bar.b13) {Insert Text}
set hint(.bar.b14) {Insert a Picture}
set hint(.bar.b15) {Insert a Line}

set hint(.bar.b17) {Bring Object To Front}
set hint(.bar.b18) {Send Object To Back}

set hint(.bar.b20) {Left Align Text}
set hint(.bar.b21) {Right Align Text}
set hint(.bar.b22) {Center Align Text}

set hint(.show) {View Slideshow}
set hint(.prsld) {Goto Previous Slide}
set hint(.nxsld) {Goto Next Slide}
set hint(.lout) {Change Slide Background}
set hint(.nsld) {Insert a new blank slide}
}

proc canvasBind {} {
	global sld hint xtopadd ytopadd
#### binding for object motion
	.c.c bind slide <1> {objectStartMove %x %y}
	.c.c bind slide <B1-Motion> {objectMove %x %y}
	.c.c bind slide <Motion> {objectResize %x %y}
	.c.c bind slide <Leave> {.c.c config -cursor $sld(cursor)}
	.c.c bind slide <Shift-1> {objectSelectAdd %x %y}
	.c.c bind slide <Double-1> {objectOptions %x %y}

#### keyboard accelerators
	bind kbdAccelerator <Page_Up> prevSlide
	bind kbdAccelerator <Page_Down> nextSlide
	bind kbdAccelerator <Control-t> menuGotoSlide 
	bind kbdAccelerator <Control-n> fileNew
	bind kbdAccelerator <Control-s> fileSave
	bind kbdAccelerator <Control-o> fileLoad
	bind kbdAccelerator <Control-q> "saveConfig; exit"
	bind kbdAccelerator <Control-v> pasteObject
	bind kbdAccelerator <Control-c> copyObject
	bind kbdAccelerator <Control-x> cutObject
	bind kbdAccelerator <Control-f> frontObject
	bind kbdAccelerator <Control-b> backObject
	bind kbdAccelerator <Control-g> groupObjects
	bind kbdAccelerator <Control-Shift-G> ungroupObjects
	bind kbdAccelerator <Control-d> duplObject
        bind kbdAccelerator <Control-e> slideshow_end
### create a binding tag for the keyboard accelerators
	set tags [bindtags .]
	bindtags . [linsert $tags 0 kbdAccelerator]

### binding to find when the visible part of canvas is resized by the user
	bind .c.c <Configure> resizedCanvas

#### Just for when we have the Presentation mode...
#### OK, maybe not exactly that, but hey! :)
	bind . <Control-F7> slideshow
	


## not canvas related, but updates status line for each button or menu
## entered (a simple context sensitive help)
	bind Menubutton <Enter> {+showHints %W}
	bind Button <Enter> {+showHints %W}
	bind Menu <Motion> {+showHints %W %y}

	setHints

	wm minsize . 200 150
	tkwait visibility .

## get the margins to add to canvas geometry
	regexp {([0-9]*)x([0-9]*)\+.*} \
		[wm geometry .] all topwidth topheight rest
	set xtopadd [expr $topwidth - $sld(width)]
	set ytopadd [expr $topheight - $sld(height)]

## bind resize of toplevel, so we could resize also the canvas
bind . <Configure> {+resizeCanvas}

## binding for moving the rulers
bind .c.cscrollh <ButtonRelease> {+moveRulers}
bind .c.cscrollv <ButtonRelease> {+moveRulers}
bind .c.cscrollh <Leave> {+moveRulers}
bind .c.cscrollv <Leave> {+moveRulers}

makeRulers

## bindings for the bindtags

bind . <Escape> "undoBindings" 

bind text <1> {txt_sel %x %y}
bind text <KeyPress> {txt_add %A}
bind text <KeyPress-Return> {txt_add "\n"}
bind text <KeyPress-BackSpace> {txt_bks}
bind text <KeyPress-Escape> {txt_done}
bind text <B1-Motion> {}
bind text <ButtonRelease-1> {}
bind text <Left> {txt_move_insert left}
bind text <Right> {txt_move_insert right}

bind show <3> {nextSlide}
bind show <Shift-1> {hiliteItem %x %y}
bind show <1> {prevSlide ; break}
		
bind line <1> {insertLine %x %y} 
bind line <B1-Motion> {insertLineMove %x %y} 
bind line <ButtonRelease-1> {insertLineEnd %x %y}

bind frame <1> {insertLine %x %y} 
bind frame <ButtonRelease-1> {insertBoxEnd %x %y} 
bind frame <B1-Motion> {insertBoxMove %x %y}

bind ellipse <1> {insertLine %x %y} 
bind ellipse <ButtonRelease-1> {insertEllipseEnd %x %y} 
bind ellipse <B1-Motion> {insertEllipseMove %x %y}

bind image <1> {insertImage %x %y} 
bind image <ButtonRelease-1> {}
bind image <B1-Motion> {}
}

proc saveHints { } {
	global hint
	set f [open hints.dat w]
	foreach n [array names hint] {
		puts $f "set hint($n) \{$hint($n)\}"
	}
	close $f
}

#
# doBindings -- modify canvas bindings so that kind of object is concerned
# also sets cursor to reflect which objects will be inserted
#
proc doBindings {t} {
	global fillbox 
	bindtags .c.c {.c.c Canvas . all}
	switch $t {
	slideshow {
		setCursor star
		bindtags .c.c {show .c.c Canvas . all}
		}
	line	{
	      setCursor ul_angle
	      bindtags .c.c {line .c.c Canvas . all}
	}
	
	frame { 
		setCursor ul_angle
		set fillbox 0
		bindtags .c.c {frame .c.c Canvas . all}
	}
	line {
		setCursor ul_angle
		bindtags .c.c {line .c.c Canvas . all}
	}
	box {
		setCursor ul_angle
		set fillbox 1
		bindtags .c.c {frame .c.c Canvas . all}
	}
	ellipse {
		setCursor ul_angle
		set fillbox 0
		bindtags .c.c {ellipse .c.c Canvas . all}
	}
	fellipse {
		setCursor ul_angle
		set fillbox 1
		bindtags .c.c {ellipse .c.c Canvas . all}
	}
	text {
		setCursor xterm
		bindtags .c.c {text .c.c Canvas . all}
	}
	image {
		setCursor draped_box
		bindtags .c.c {image .c.c Canvas . all}
	}
	}
}

#
# undoBindings --- just the opposite, clears the mouse...
#
proc undoBindings {} {
	global fillbox boxedtext
	
		setCursor xterm
		bind .c.c <1> {}
		bind .c.c <3> {}
		bind .c.c <> {}
}
